import tkinter as tk
from PIL import Image, ImageDraw, ImageFont
import barcode
from barcode.writer import ImageWriter
import os
from PIL import Image, ImageDraw, ImageFont
import barcode
from barcode.writer import ImageWriter

def generate_waybill():
    # 获取用户输入
    url = "1nvweb.top"
    waybill_number = waybill_entry.get()
    recipient_name = name_entry.get()
    recipient_address = address_entry.get()
    recipient_phone = phone_entry.get()

    # 创建条形码
    BARCODE = barcode.get_barcode_class('code128')
    barcode_img = BARCODE(waybill_number, writer=ImageWriter())
    barcode_path = "barcode"  # 默认保存到当前目录
    barcode_pathb = "barcode.png"
    try:
        barcode_img.save(barcode_path)  # 保存条形码图片
    except Exception as e:
        status_label.config(text=f"条形码生成失败: {e}")
        return

    # 检查条形码文件是否存在
    if not os.path.exists(barcode_pathb):
        status_label.config(text="条形码文件未找到")
        return

    # 创建面单图片（比例 130:76）
    width, height = 1300, 760
    img = Image.new('RGB', (width, height), color='white')
    draw = ImageDraw.Draw(img)

    # 加载字体
    try:
        url_font = ImageFont.truetype("arial.ttf", 40)
        waybill_font = ImageFont.truetype("arial.ttf", 50)
        info_font = ImageFont.truetype("arial.ttf", 45)
    except:
        url_font = ImageFont.load_default()
        waybill_font = ImageFont.load_default()
        info_font = ImageFont.load_default()

    # 绘制左上角网址
    draw.text((20, 20), url, font=url_font, fill='black')

    # 绘制居中条形码
    try:
        barcode_img = Image.open(barcode_pathb)
        barcode_width, barcode_height = barcode_img.size
        barcode_x = (width - barcode_width) // 2
        barcode_y = 100
        img.paste(barcode_img, (barcode_x, barcode_y))
    except Exception as e:
        status_label.config(text=f"打开条形码失败: {e}")
        return

    # 绘制居中运单号
    waybill_text_width = draw.textlength(waybill_number, font=waybill_font)
    waybill_x = (width - waybill_text_width) // 2
    waybill_y = barcode_y + barcode_height + 20
    draw.text((waybill_x, waybill_y), waybill_number, font=waybill_font, fill='black')

    # 绘制收件人信息
    info_start_y = waybill_y + 80
    draw.text((20, info_start_y), f"收件人姓名: {recipient_name}", font=info_font, fill='black')
    draw.text((20, info_start_y + 60), f"收件人地址: {recipient_address}", font=info_font, fill='black')
    draw.text((20, info_start_y + 120), f"收件人手机号: {recipient_phone}", font=info_font, fill='black')

    # 保存面单图片
    img.save("waybill.png")
    status_label.config(text="面单已生成并保存为 waybill.png")
# 创建 GUI 界面
root = tk.Tk()
root.title("快递面单生成器")
root.geometry("800x300")  # 设置窗口大小

# 输入框和标签
tk.Label(root, text="运单号:", font=("Arial", 12)).grid(row=0, column=0, padx=10, pady=10, sticky="e")
waybill_entry = tk.Entry(root, width=30)
waybill_entry.grid(row=0, column=1, padx=10, pady=10)

tk.Label(root, text="收件人姓名:", font=("Arial", 12)).grid(row=1, column=0, padx=10, pady=10, sticky="e")
name_entry = tk.Entry(root, width=30)
name_entry.grid(row=1, column=1, padx=10, pady=10)

tk.Label(root, text="收件人地址:", font=("Arial", 12)).grid(row=2, column=0, padx=10, pady=10, sticky="e")
address_entry = tk.Entry(root, width=30)
address_entry.grid(row=2, column=1, padx=10, pady=10)

tk.Label(root, text="收件人手机号:", font=("Arial", 12)).grid(row=3, column=0, padx=10, pady=10, sticky="e")
phone_entry = tk.Entry(root, width=30)
phone_entry.grid(row=3, column=1, padx=10, pady=10)

# 生成按钮
generate_button = tk.Button(root, text="生成面单", font=("Arial", 12), command=generate_waybill)
generate_button.grid(row=4, column=0, columnspan=2, pady=20)

# 状态提示
status_label = tk.Label(root, text="", font=("Arial", 10))
status_label.grid(row=5, column=0, columnspan=2)

root.mainloop()