import tkinter as tk
from PIL import Image, ImageDraw, ImageFont
import barcode
from barcode.writer import ImageWriter
import os
from PIL import Image, ImageDraw, ImageFont
import barcode
from barcode.writer import ImageWriter

from PIL import Image, ImageDraw, ImageFont
import os

from PIL import Image, ImageDraw, ImageFont
import os

from PIL import Image, ImageDraw, ImageFont
import os

def generate_waybill():
    # 获取用户输入
    url = "1nvweb.top"
    waybill_number = waybill_entry.get()
    recipient_name = name_entry.get()
    recipient_address = address_entry.get()
    recipient_phone = phone_entry.get()
    recipient_qujianma = qujianma_entry.get()

    # 创建条形码
    BARCODE = barcode.get_barcode_class('code128')
    barcode_img = BARCODE(waybill_number, writer=ImageWriter())
    barcode_img.writer.text = False  # 禁用条形码下方的数字显示
    barcode_path = "barcode"
    barcode_pathb = "barcode.png"
    try:
        barcode_img.save(barcode_path)
    except Exception as e:
        status_label.config(text=f"条形码生成失败: {e}")
        return

    # 检查条形码文件是否存在
    if not os.path.exists(barcode_pathb):
        status_label.config(text="条形码文件未找到")
        return

    # 创建面单图片（比例 130:76）
    width, height = 760, 1300
    img = Image.new('RGB', (width, height), color='white')
    draw = ImageDraw.Draw(img)

    # 使用支持中文的字体，指定字体文件路径
    try:
        url_font = ImageFont.truetype("C:/Windows/Fonts/simhei.ttf", size=50)  # Windows 默认的 SimHei 字体
        waybill_font = ImageFont.truetype("C:/Windows/Fonts/simhei.ttf", size=20)
        info_font = ImageFont.truetype("C:/Windows/Fonts/simhei.ttf", size=30)
        qujianma_font = ImageFont.truetype("C:/Windows/Fonts/simhei.ttf", size=60)
    except Exception as e:
        status_label.config(text=f"加载字体失败: {e}")
        return

    # 绘制左上角网址
    draw.text((20, 20), url, font=url_font, fill='black')

    # 绘制居中条形码
    try:
        barcode_img = Image.open(barcode_pathb)
        barcode_width, barcode_height = barcode_img.size
        barcode_x = (width - barcode_width) // 2
        barcode_y = 100
        img.paste(barcode_img, (barcode_x, barcode_y))
    except Exception as e:
        status_label.config(text=f"打开条形码失败: {e}")
        return

    # 绘制居中运单号
    waybill_text_width = draw.textlength(waybill_number, font=waybill_font)
    waybill_x = (width - waybill_text_width) // 2
    waybill_y = barcode_y + barcode_height + 10
    draw.text((waybill_x, waybill_y), waybill_number, font=waybill_font, fill='black')

    # 绘制收件人信息
    info_start_y = waybill_y + 80
    draw.text((20, info_start_y), f"收件人姓名: {recipient_name}", font=info_font, fill='black')
    draw.text((20, info_start_y + 60), f"收件人地址: {recipient_address}", font=info_font, fill='black')
    draw.text((20, info_start_y + 120), f"收件人手机号: {recipient_phone}", font=info_font, fill='black')
    draw.text((20, info_start_y + 190), f"-------------------------------------------------------", font=info_font, fill='black')
    draw.text((20, info_start_y + 240), f"发货人手机号132****1935", font=info_font, fill='black')
    draw.text((20, info_start_y + 300), f"快递员取件码:{recipient_qujianma}", font=qujianma_font, fill='black')

    # 保存面单图片
    img.save("waybill.png")
    status_label.config(text="面单已生成并保存为 waybill.png")



# 创建 GUI 界面
root = tk.Tk()
root.title("快递面单生成器")
root.geometry("800x300")  # 设置窗口大小

# 输入框和标签
tk.Label(root, text="运单号:", font=("Arial", 12)).grid(row=0, column=0, padx=10, pady=10, sticky="e")
waybill_entry = tk.Entry(root, width=30)
waybill_entry.grid(row=0, column=1, padx=10, pady=10)

tk.Label(root, text="收件人姓名:", font=("Arial", 12)).grid(row=1, column=0, padx=10, pady=10, sticky="e")
name_entry = tk.Entry(root, width=30)
name_entry.grid(row=1, column=1, padx=10, pady=10)

tk.Label(root, text="收件人地址:", font=("Arial", 12)).grid(row=2, column=0, padx=10, pady=10, sticky="e")
address_entry = tk.Entry(root, width=30)
address_entry.grid(row=2, column=1, padx=10, pady=10)

tk.Label(root, text="收件人手机号:", font=("Arial", 12)).grid(row=3, column=0, padx=10, pady=10, sticky="e")
phone_entry = tk.Entry(root, width=30)
phone_entry.grid(row=3, column=1, padx=10, pady=10)

tk.Label(root, text="快递员取件码:", font=("Arial", 12)).grid(row=4, column=0, padx=10, pady=10, sticky="e")
qujianma_entry = tk.Entry(root, width=30)
qujianma_entry.grid(row=4, column=1, padx=10, pady=10)

# 生成按钮
generate_button = tk.Button(root, text="生成面单", font=("Arial", 12), command=generate_waybill)
generate_button.grid(row=5, column=0, columnspan=2, pady=20)

# 状态提示
status_label = tk.Label(root, text="", font=("Arial", 10))
status_label.grid(row=6, column=0, columnspan=2)

root.mainloop()